Option Strict On
Option Explicit On 

Imports Interop.QBFC5
Module BuildCustomerAddRqModule

    Public Sub BuildCustomerAddRq(ByVal cust As Customer, ByVal requestMsgSet As IMsgSetRequest, ByVal country As String)

        If (requestMsgSet Is Nothing) Then
            Exit Sub
        End If

        'Add the request to the message set request object. 
        Dim customerAdd As ICustomerAdd
        customerAdd = requestMsgSet.AppendCustomerAddRq()

        'Set the elements of ICustomerAdd. 

        ' Set the value of the ICustomerAdd.Name element. 
        customerAdd.Name.SetValue(cust.getQBName)

        ' Set the value of the ICustomerAdd.IsActive element. 
        customerAdd.IsActive.SetValue(True)

        ' Set the value of the ICustomerAdd.CompanyName element. 
        customerAdd.CompanyName.SetValue(cust.companyName)

        ' Set the value of the ICustomerAdd.FirstName element. 
        customerAdd.FirstName.SetValue(cust.firstName)

        ' Set the value of the ICustomerAdd.LastName element. 
        customerAdd.LastName.SetValue(cust.lastName)

        ' Set the value of the IAddress.Addr1 element. 
        customerAdd.BillAddress.Addr1.SetValue(cust.companyName)
        customerAdd.BillAddress.Addr2.SetValue(cust.firstName & " " & cust.lastName)
        customerAdd.BillAddress.Addr3.SetValue(cust.streetAddress)

        ' Set the value of the IAddress.City element. 
        customerAdd.BillAddress.City.SetValue(cust.city)

        If (country = "US") Then
            ' Set the value of the IAddress.State element. 
            customerAdd.BillAddress.State.SetValue(cust.state)

        End If
        If (country = "UK") Then
            ' Set the value of the IAddress.County element. 
            customerAdd.BillAddress.County.SetValue(cust.state)

        End If
        If (country = "CA") Then
            ' Set the value of the IAddress.Province element. 
            customerAdd.BillAddress.Province.SetValue(cust.state)

        End If
        ' Set the value of the IAddress.PostalCode element. 
        customerAdd.BillAddress.PostalCode.SetValue(cust.postcode)

        ' Set the value of the IAddress.Country element. 
        customerAdd.BillAddress.Country.SetValue(cust.country)

        ' Set the value of the IAddress.Addr1 element. 
        customerAdd.ShipAddress.Addr1.SetValue(cust.companyName)
        customerAdd.ShipAddress.Addr2.SetValue(cust.firstName & " " & cust.lastName)
        customerAdd.ShipAddress.Addr3.SetValue(cust.streetAddress)

        ' Set the value of the IAddress.City element. 
        customerAdd.ShipAddress.City.SetValue(cust.city)

        If (country = "US") Then
            ' Set the value of the IAddress.State element. 
            customerAdd.ShipAddress.State.SetValue(cust.state)

        End If
        If (country = "UK") Then
            ' Set the value of the IAddress.County element. 
            customerAdd.ShipAddress.County.SetValue(cust.state)

        End If
        If (country = "CA") Then
            ' Set the value of the IAddress.Province element. 
            customerAdd.ShipAddress.Province.SetValue(cust.state)

        End If
        ' Set the value of the IAddress.PostalCode element. 
        customerAdd.ShipAddress.PostalCode.SetValue(cust.postcode)

        ' Set the value of the ICustomerAdd.Phone element. 
        customerAdd.Phone.SetValue(cust.telephone)

        ' Set the value of the ICustomerAdd.Fax element. 
        customerAdd.Fax.SetValue(cust.fax)

        
        ' Set the value of the ICustomerAdd.Email element. 
        customerAdd.Email.SetValue(cust.emailAddress)

        ' Set the FullName value. 
        customerAdd.SalesTaxCodeRef.FullName.SetValue(cust.salesTaxCode)

        If (cust.group = "Retail") Then
            ''Set terms??
        Else
            customerAdd.TermsRef.FullName.SetValue("Net 30")
        End If

        customerAdd.Notes.SetValue(cust.notes)

        customerAdd.IncludeRetElementList.Add("ListID")
        customerAdd.IncludeRetElementList.Add("EditSequence")
        customerAdd.IncludeRetElementList.Add("Name")
    End Sub
End Module

