Imports Interop.QBFC5

Module BuildInventoryAdjustmentAddRqModule
    Public Sub BuildInventoryAdjustmentAddRq(ByVal invAdj As InventoryAdjustment, ByVal requestMsgSet As IMsgSetRequest)

        If (requestMsgSet Is Nothing) Then
            Exit Sub
        End If

        'Add the request to the message set request object.
        Dim inventoryAdjustmentAdd As IInventoryAdjustmentAdd
        inventoryAdjustmentAdd = requestMsgSet.AppendInventoryAdjustmentAddRq()

        'Set the elements of IInventoryAdjustmentAdd.

        ' Set the ListID value.
        inventoryAdjustmentAdd.AccountRef.FullName.SetValue("Cost of Goods Sold:Change in Inventory")

        ' Set the value of the IInventoryAdjustmentAdd.TxnDate element.
        inventoryAdjustmentAdd.TxnDate.SetValue(invAdj.adjustmentDate)

        ' Set the FullName value.
        inventoryAdjustmentAdd.ClassRef.FullName.SetValue("RC:RC Wholesale")

        ' Set the value of the IInventoryAdjustmentAdd.Memo element.
        inventoryAdjustmentAdd.Memo.SetValue(invAdj.memo)

        'Add multiple elements to the list. In this case we will add 5 elements.
        Dim inventoryAdjustmentLineAdd1 As IInventoryAdjustmentLineAdd
        Dim j As Integer

        ' Append an element to the list and save the element in inventoryAdjustmentLineAdd1 so we can set its values.
        inventoryAdjustmentLineAdd1 = inventoryAdjustmentAdd.InventoryAdjustmentLineAddList.Append()

        ' Set the ListID value.
        inventoryAdjustmentLineAdd1.ItemRef.ListID.SetValue(invAdj.productListId)

        If (invAdj.type = 0) Then
            ' Set the value of the IORQuantityAdjustment.NewQuantity element.
            inventoryAdjustmentLineAdd1.ORTypeAdjustment.QuantityAdjustment.ORQuantityAdjustment.NewQuantity.SetValue(invAdj.quantity)

        ElseIf (invAdj.type = 1) Then
            ' Set the value of the IORQuantityAdjustment.QuantityDifference element.
            inventoryAdjustmentLineAdd1.ORTypeAdjustment.QuantityAdjustment.ORQuantityAdjustment.QuantityDifference.SetValue(invAdj.quantity)
        ElseIf (invAdj.type = 3) Then
            Debug.WriteLine("New Value: " & invAdj.value)
            inventoryAdjustmentLineAdd1.ORTypeAdjustment.ValueAdjustment.NewValue.SetValue(String.Format("{0:n2}", invAdj.value))
        End If

        ' Set the value of the IInventoryAdjustmentAdd.IncludeRetElementList element.
        inventoryAdjustmentAdd.IncludeRetElementList.Add("ListID")
        inventoryAdjustmentAdd.IncludeRetElementList.Add("EditSequence")

    End Sub
End Module
