Imports Interop.QBFC5
Module BuildItemInventoryQueryRqModule

    Public Sub BuildItemInventoryQueryRq(ByVal listId As String, ByVal requestMsgSet As IMsgSetRequest)

        If (requestMsgSet Is Nothing) Then
            Exit Sub
        End If

        'Add the request to the message set request object. 
        Dim itemInventoryQuery As IItemInventoryQuery
        itemInventoryQuery = requestMsgSet.AppendItemInventoryQueryRq()

        ' Set the value of the IORListQuery.ListIDList element. 
        itemInventoryQuery.ORListQuery.ListIDList.Add(listId)

        ' Set the value of the IItemInventoryQuery.IncludeRetElementList element. 
        itemInventoryQuery.IncludeRetElementList.Add("ListID")
        itemInventoryQuery.IncludeRetElementList.Add("Name")
        itemInventoryQuery.IncludeRetElementList.Add("EditSequence")
        itemInventoryQuery.IncludeRetElementList.Add("QuantityOnHand")
        itemInventoryQuery.IncludeRetElementList.Add("AverageCost")
    End Sub

    Public Sub DoItemInventoryQueryRq(ByVal nameStart As String, ByVal nameEnd As String, ByVal requestMsgSet As IMsgSetRequest)
        If (requestMsgSet Is Nothing) Then
            Exit Sub
        End If

        Dim itemInventoryQuery As IItemInventoryQuery
        itemInventoryQuery = requestMsgSet.AppendItemInventoryQueryRq()

        itemInventoryQuery.ORListQuery.ListFilter.ORNameFilter.NameRangeFilter.FromName.SetValue(nameStart)
        itemInventoryQuery.ORListQuery.ListFilter.ORNameFilter.NameRangeFilter.ToName.SetValue(nameEnd)
        ' Set the value of the IItemInventoryQuery.IncludeRetElementList element. 
        itemInventoryQuery.IncludeRetElementList.Add("ListID")
        itemInventoryQuery.IncludeRetElementList.Add("Name")
        itemInventoryQuery.IncludeRetElementList.Add("EditSequence")
        itemInventoryQuery.IncludeRetElementList.Add("QuantityOnHand")
        itemInventoryQuery.IncludeRetElementList.Add("AverageCost")
    End Sub
End Module

