Imports Interop.QBFC5
Imports System.Text.RegularExpressions


Module modSynch
    Public dbConn As ADODB.Connection
    Public dbCustomers() As Customer
    Public dbOrders(2) As Order
    Public dbItems() As Item
    Public pgBar As ProgressBar
    Public lbStatus As Label
    Public cbxPerformanceLogic As CheckBox
    Dim INVENTORY_ASSET_ACCOUNT = "Inventory Asset:Inventory Part"

    Sub synchInventoryAdjustments()
        Dim strSQL As String
        Dim dbCommand As New ADODB.Command
        Dim dbRS As New ADODB.Recordset
        Dim dbrs2 As New ADODB.Recordset
        Dim sessionManager As QBSessionManager
        Dim msgSetRs As IMsgSetResponse

        ' Get adjustments not posted yet for products that have previously been synched.
        strSQL = "SELECT inventory_adjustments_id, p.products_id, difference, txdate, ref_number, memo, p.qb_list_id as products_list_id " & _
                "FROM inventory_adjustments ia " & _
                "INNER JOIN products p ON (ia.products_id = p.products_id)" & _
                "WHERE ia.qb_edit_seq is NULL AND p.qb_edit_seq is NOT NULL"
        dbCommand.ActiveConnection = dbConn
        dbCommand.CommandText = strSQL

        Try
            sessionManager = New QBSessionManagerClass
            Dim msgSetRq As IMsgSetRequest = sessionManager.CreateMsgSetRequest("US", 5, 0)
            sessionManager.OpenConnection("osc2QB", "osCommerce Integration Program")
            sessionManager.BeginSession("", ENOpenMode.omDontCare)

            msgSetRq.Attributes.OnError = ENRqOnError.roeContinue
            dbRS = dbCommand.Execute
            Dim invAdj As InventoryAdjustment
            Dim invAdjRet As IInventoryAdjustmentRet
            While Not dbRS.EOF
                invAdj = New InventoryAdjustment
                invAdj.type = 1
                invAdj.quantity = CInt(dbRS.Fields("difference").Value)
                invAdj.adjustmentDate = CDate(dbRS.Fields("txdate").Value)
                invAdj.productListId = dbRS.Fields("products_list_id").Value
                invAdj.memo = "Online Adjustment: " & dbRS.Fields("memo").Value

                msgSetRq.ClearRequests()
                BuildInventoryAdjustmentAddRq(invAdj, msgSetRq)
                Debug.WriteLine(msgSetRq.ToXMLString)
                msgSetRs = sessionManager.DoRequests(msgSetRq)
                Debug.WriteLine(msgSetRs.ToXMLString)
                invAdjRet = ParseInventoryAdjustmentAddRs(msgSetRs)
                dbConn.Execute("UPDATE inventory_adjustments SET qb_edit_seq='" & invAdjRet.EditSequence.GetValue & "' WHERE inventory_adjustments_id=" & dbRS.Fields("inventory_adjustments_id").Value)

                Debug.WriteLine(CDate(dbRS.Fields("txdate").Value))
                dbRS.MoveNext()
            End While
            pgBar.Value = 0
        Catch ex As Exception
            MessageBox.Show("Oops, we encountered an error:" & ex.Message & vbCrLf & ex.StackTrace)
        Finally
            If Not dbRS Is Nothing Then
                dbRS.Close()
            End If
            If Not sessionManager Is Nothing Then
                sessionManager.EndSession()
                sessionManager.CloseConnection()
            End If
        End Try


    End Sub

    Sub SynchOrders()
        Dim strSQL As String
        Dim dbCommand As New ADODB.Command
        Dim dbRS As New ADODB.Recordset
        Dim dbrs2 As New ADODB.Recordset
        Dim dbrs3 As New ADODB.Recordset

        strSQL = "SELECT o.orders_id, o.date_purchased, c.customers_group_id, " & _
                    "o.billing_company, o.billing_name, o.billing_street_address, o.billing_city, o.billing_postcode, o.billing_state, o.billing_country, " & _
                    "o.delivery_company, o.delivery_name, o.delivery_street_address, o.delivery_city, o.delivery_postcode, o.delivery_state, o.delivery_country, " & _
                    "o.purchase_order_number, o.customers_notes, o.payment_method, " & _
                    "COALESCE(ot1.value,0) AS shipping_amount, ot1.title AS shipping_description, " & _
                    "COALESCE(ot2.value,0) AS salestax_amount, " & _
                    "COALESCE(ot3.value,0) + 0 AS gift_amount, " & _
                    "COALESCE(ot4.value,0) + 0 AS coupon_amount, " & _
                    "COALESCE(ot3.title,'') as gift_description, " & _
                    "COALESCE(ot4.title,'') as coupon_description, " & _
                    "COALESCE(ot5.value,'') as order_total, " & _
                    "c.qb_list_id as customers_list_id " & _
                 "FROM orders o " & _
                 "INNER JOIN customers c ON (o.customers_id = c.customers_id) " & _
                 "LEFT JOIN orders_total ot1 ON (o.orders_id=ot1.orders_id AND ot1.class='ot_shipping') " & _
                 "LEFT JOIN orders_total ot2 ON (o.orders_id=ot2.orders_id AND ot2.class='ot_tax') " & _
                 "LEFT JOIN orders_total ot3 ON (o.orders_id=ot3.orders_id AND ot3.class='ot_gv') " & _
                 "LEFT JOIN orders_total ot4 ON (o.orders_id=ot4.orders_id AND ot4.class='ot_coupon') " & _
                 "INNER JOIN orders_total ot5 ON (o.orders_id=ot5.orders_id AND ot5.class='ot_total'  AND ot5.value>=0) " & _
                 "WHERE o.orders_status = 3 AND c.qb_list_id is not null AND o.qb_edit_seq is null"
        dbCommand.ActiveConnection = dbConn
        dbCommand.CommandText = "SELECT count(*) " & _
                 "FROM orders o " & _
                 "INNER JOIN customers c ON (o.customers_id = c.customers_id) " & _
                 "LEFT JOIN orders_total ot1 ON (o.orders_id=ot1.orders_id AND ot1.class='ot_shipping') " & _
                 "LEFT JOIN orders_total ot2 ON (o.orders_id=ot2.orders_id AND ot2.class='ot_tax') " & _
                 "LEFT JOIN orders_total ot3 ON (o.orders_id=ot3.orders_id AND ot3.class='ot_gv') " & _
                 "LEFT JOIN orders_total ot4 ON (o.orders_id=ot4.orders_id AND ot4.class='ot_coupon') " & _
                 "INNER JOIN orders_total ot5 ON (o.orders_id=ot5.orders_id AND ot5.class='ot_total' AND ot5.value>=0) " & _
                 "WHERE o.orders_status = 3 AND c.qb_list_id is not null AND o.qb_edit_seq is null "
        dbRS = dbCommand.Execute
        dbRS.MoveFirst()
        Dim ordersCount = dbRS.Fields(0).Value
        dbCommand.CommandText = strSQL
        dbRS = dbCommand.Execute

        Dim sessionManager As QBSessionManager
        Dim msgSetRs As IMsgSetResponse

        pgBar.Minimum = 0
        pgBar.Maximum = ordersCount
        Dim i As Integer = 0
        Dim o As Order

        Try
            sessionManager = New QBSessionManagerClass
            Dim msgSetRq As IMsgSetRequest = sessionManager.CreateMsgSetRequest("US", 5, 0)
            sessionManager.OpenConnection("osc2QB", "osCommerce Integration Program")
            sessionManager.BeginSession("", ENOpenMode.omDontCare)

            msgSetRq.Attributes.OnError = ENRqOnError.roeContinue
            Dim messagesPresent As Boolean = False


            While Not dbRS.EOF
                ReDim Preserve dbOrders(i)
                o = New Order

                o.customerListId = dbRS.Fields("customers_list_id").Value
                o.id = dbRS.Fields("orders_id").Value
                o.transactionDate = dbRS.Fields("date_purchased").Value
                o.billingName = FixNull(dbRS.Fields("billing_name").Value)
                o.billingCompany = FixNull(dbRS.Fields("billing_company").Value)
                o.billingStreetAddress = dbRS.Fields("billing_street_address").Value
                o.billingCity = dbRS.Fields("billing_city").Value
                o.billingState = dbRS.Fields("billing_state").Value
                o.billingPostcode = dbRS.Fields("billing_postcode").Value
                o.billingCountry = dbRS.Fields("billing_country").Value
                o.shipMethod = FixNull(dbRS.Fields("shipping_description").Value)
                o.shippingName = FixNull(dbRS.Fields("delivery_name").Value)
                o.shippingCompany = FixNull(dbRS.Fields("delivery_company").Value)
                o.shippingStreetAddress = dbRS.Fields("delivery_street_address").Value
                o.shippingCity = dbRS.Fields("delivery_city").Value
                o.shippingState = dbRS.Fields("delivery_state").Value
                o.shippingPostcode = dbRS.Fields("delivery_postcode").Value
                o.shippingCountry = dbRS.Fields("delivery_country").Value
                o.poNumber = FixNull(dbRS.Fields("purchase_order_number").Value)
                o.salesTaxAmount = dbRS.Fields("salestax_amount").Value
                o.couponAmount = dbRS.Fields("coupon_amount").Value
                o.giftAmount = dbRS.Fields("gift_amount").Value
                o.shippingAmount = dbRS.Fields("shipping_amount").Value
                o.paymentMethod = dbRS.Fields("payment_method").Value
                o.totalAmount = FixNull(dbRS.Fields("order_total").Value)
                o.notes = FixNull(dbRS.Fields("customers_notes").Value)
                Dim sql = "SELECT date_added as date_shipped FROM orders_status_history WHERE orders_id='" & o.id & "' AND orders_status_id='3' ORDER BY date_added ASC"
                dbrs3.Open(sql, dbConn)
                If Not dbrs3.EOF Then
                    o.shipDate = dbrs3.Fields("date_shipped").Value
                End If
                dbrs3.Close()

                '' FIX FOR NEGATIVE VALUES:
                If o.couponAmount > 0 And o.totalAmount < 0 Then
                    o.couponAmount = o.couponAmount + o.totalAmount
                ElseIf o.giftAmount > 0 And o.totalAmount < 0 Then
                    o.giftAmount = o.giftAmount + o.totalAmount
                End If

                If dbRS.Fields("customers_group_id").Value = "1" Then
                    o.className = "RC:RC Wholesale"
                Else
                    o.className = "RC:RC Retail"
                End If
                dbrs2.Open("SELECT op.products_id, op.products_model, op.products_name, op.final_price, op.products_quantity, op.products_tax FROM orders_products op INNER JOIN products p ON (p.products_id=op.products_id) WHERE op.orders_id='" & o.id & "'", dbConn)
                Dim lineItem As OrderLineItem
                Dim lineDBTaxAmount As Double
                While Not dbrs2.EOF
                    lineItem = New OrderLineItem
                    lineItem.itemRefName = dbrs2.Fields("products_id").Value
                    lineItem.description = stripTags(dbrs2.Fields("products_name").Value).Replace("&nbsp;", "")
                    lineItem.amount = dbrs2.Fields("final_price").Value
                    lineItem.quantity = dbrs2.Fields("products_quantity").Value
                    lineDBTaxAmount = dbrs2.Fields("products_tax").Value
                    If lineItem.amount < 0 Then
                        lineItem.itemRefName = "Discount"
                    End If
                    If lineDBTaxAmount > 0 Then
                        lineItem.isTaxable = True
                    End If
                    o.addLineItem(lineItem)
                    dbrs2.MoveNext()
                End While
                dbrs2.Close()

                If o.shippingAmount > 0 Then
                    lineItem = New OrderLineItem
                    lineItem.itemRefName = "Shipping"
                    lineItem.description = stripTags(FixNull(dbRS.Fields("shipping_description").Value)).Replace("&nbsp;", "")
                    lineItem.quantity = 1
                    lineItem.amount = Math.Round(o.shippingAmount, 2)
                    o.addLineItem(lineItem)
                End If

                If o.couponAmount > 0 Then
                    lineItem = New OrderLineItem
                    lineItem.itemRefName = "Discount"
                    lineItem.description = stripTags(FixNull(dbRS.Fields("coupon_description").Value)).Replace("&nbsp;", "")
                    lineItem.quantity = 1
                    lineItem.amount = Math.Round(o.couponAmount, 2) * (-1.0)
                    o.addLineItem(lineItem)
                End If
                If o.giftAmount > 0 Then
                    lineItem = New OrderLineItem
                    lineItem.itemRefName = "Discount"
                    lineItem.description = stripTags(FixNull(dbRS.Fields("gift_description").Value)).Replace("&nbsp;", "")
                    lineItem.quantity = 1
                    lineItem.amount = Math.Round(o.giftAmount, 2) * (-1.0)
                    o.addLineItem(lineItem)
                End If

                If o.paymentMethod = "Credit Card" Or o.paymentMethod = "PayPal" Then
                    '' Sales Receipt:

                    If o.paymentMethod = "PayPal" Then
                        ''''''''o.depositAccount = "Bank:PAYPAL"
                    Else
                        '''''''''o.depositAccount = "Bank:WAMU #792"
                    End If
                    BuildSalesReceiptAddRq(o, msgSetRq, "US")

                ElseIf o.totalAmount <= 0 Then
                    o.paymentMethod = "Cash"
                    '''''''''''o.depositAccount = "Bank:WAMU #792"
                    BuildSalesReceiptAddRq(o, msgSetRq, "US")
                Else
                    '' Invoice:
                    BuildInvoiceAddRq(o, msgSetRq, "US")
                End If

                messagesPresent = True
                If msgSetRq.RequestList.Count > 25 Then
                    lbStatus.Text = "Committing Order batch to QuickBooks..."
                    msgSetRs = sessionManager.DoRequests(msgSetRq)
                    processTransactionResponse(msgSetRs)
                    Debug.Write(msgSetRs.ToXMLString)
                    Debug.WriteLine("COUNT: " & msgSetRq.RequestList.Count)
                    msgSetRq.ClearRequests()
                    msgSetRq = Nothing
                    msgSetRq = sessionManager.CreateMsgSetRequest("US", 5, 0)
                    msgSetRq.Attributes.OnError = ENRqOnError.roeContinue
                    messagesPresent = False
                End If
                dbOrders(i) = o

                pgBar.Value = i
                lbStatus.Text = "Synchronizing Order " & o.id & "..."
                Application.DoEvents()
                Debug.Write(o.id & vbCrLf)
                dbRS.MoveNext()
                i = i + 1
            End While

            If messagesPresent Then
                msgSetRs = sessionManager.DoRequests(msgSetRq)
                processTransactionResponse(msgSetRs)
                Debug.Write(msgSetRs.ToXMLString)
            End If
            pgBar.Value = 0

        Catch ex As Exception
            MessageBox.Show(ex.Message & vbCrLf & vbCrLf & ex.StackTrace, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        Finally
            If Not sessionManager Is Nothing Then
                sessionManager.EndSession()
                sessionManager.CloseConnection()
            End If
        End Try
    End Sub

    Sub SynchProducts()
        Dim strSQL As String
        Dim dbCommand As New ADODB.Command
        lbStatus.Text = "Entered Synch Products"
        Dim dbRs As New ADODB.Recordset

        lbStatus.Text = "ADODB object created"

        ' Query the database
        strSQL = "SELECT " & _
                    "p.products_id, p.products_quantity, p.products_initial_quantity, " & _
                    "p.products_model, p.products_price, p.products_cost, " & _
                    "p.products_tax_class_id, pd.products_name, p.products_date_added, p.qb_list_id, p.qb_edit_seq " & _
                "FROM `products` p " & _
                "INNER JOIN products_description pd ON ( p.products_id = pd.products_id AND pd.language_id =1 ) "
        dbCommand.ActiveConnection = dbConn

        lbStatus.Text = "Datbase connection activated"

        dbRs.CursorType = ADODB.CursorTypeEnum.adOpenStatic
        lbStatus.Text = "Database cursor opened in static mode"
        dbRs.LockType = ADODB.LockTypeEnum.adLockPessimistic
        lbStatus.Text = "Pesimistic Lock set"

        dbCommand.CommandText = "SELECT " & _
                    "count(*) " & _
                "FROM `products` p " & _
                "INNER JOIN products_description pd ON ( p.products_id = pd.products_id AND pd.language_id =1 ) "
        dbRs = dbCommand.Execute
        lbStatus.Text = "SQL command executed"
        dbRs.MoveFirst()
        Dim itemCount = dbRs.Fields(0).Value
        dbCommand.CommandText = strSQL
        dbRs = dbCommand.Execute

        Dim sessionManager As QBSessionManager
        lbStatus.Text = "QB Session manager created"
        Dim msgSetRs As IMsgSetResponse
        lbStatus.Text = "QB Response message created"
        pgBar.Minimum = 0
        pgBar.Maximum = itemCount
        Dim i As Integer = 0
        Dim item As Item

        Try
            lbStatus.Text = "Begning QB conversation"
            sessionManager = New QBSessionManagerClass
            Dim msgSetRq As IMsgSetRequest = sessionManager.CreateMsgSetRequest("US", 5, 0)
            lbStatus.Text = "QB Session manager started"
            sessionManager.OpenConnection("osc2QB", "osCommerce Integration Program")
            lbStatus.Text = "QB Connection to QB file started"
            sessionManager.BeginSession("", ENOpenMode.omDontCare)
            lbStatus.Text = "QB session started"

            msgSetRq.Attributes.OnError = ENRqOnError.roeContinue
            Dim messagesPresent As Boolean = False

            While Not dbRs.EOF
                ReDim Preserve dbItems(i)
                item = New Item
                item.type = INVENTORY_ASSET_ACCOUNT
                item.name = dbRs.Fields("products_id").Value
                item.purchaseDescription = stripTags(FixNull(dbRs.Fields("products_model").Value))
                item.salesDescription = stripTags(FixNull(dbRs.Fields("products_name").Value))

                item.cost = dbRs.Fields("products_cost").Value
                item.price = dbRs.Fields("products_price").Value
                item.costOfGoodsSoldAccount = "Cost of Goods Sold"
                If dbRs.Fields("products_tax_class_id").Value = "1" Then
                    item.taxCode = "Tax"
                Else
                    item.taxCode = "Non"
                End If

                item.assetAccount = INVENTORY_ASSET_ACCOUNT
                item.incomeAccount = "Sales:Wholesale RC"
                item.listId = FixNull(dbRs.Fields("qb_list_id").Value)
                item.dateAdded = CDate(dbRs.Fields("products_date_added").Value)
                item.editSequence = FixNull(dbRs.Fields("qb_edit_seq").Value)

                If (Len(item.editSequence) = 0 And Len(item.listId) = 0) Then
                    item.quantityOnHand = dbRs.Fields("products_initial_quantity").Value
                    BuildItemInventoryAddRq(item, msgSetRq, "US")
                    Debug.WriteLine("ADDING :" & item.name & " (" & item.purchaseDescription & ")")
                Else
                    BuildItemInventoryModRq(item, msgSetRq, "US")
                    Debug.WriteLine("UPDATING :" & item.name & " (" & item.purchaseDescription & ")")
                End If
                messagesPresent = True
                If msgSetRq.RequestList.Count > 50 Then
                    lbStatus.Text = "Committing Products batch to QuickBooks..."
                    msgSetRs = sessionManager.DoRequests(msgSetRq)
                    Debug.Write(msgSetRs.ToXMLString())


                    processItemInventoryResponse(msgSetRs)
                    Debug.WriteLine("COUNT: " & msgSetRq.RequestList.Count)
                    msgSetRq.ClearRequests()
                    msgSetRq = Nothing
                    msgSetRq = sessionManager.CreateMsgSetRequest("US", 5, 0)
                    msgSetRq.Attributes.OnError = ENRqOnError.roeContinue
                    messagesPresent = False
                End If
                dbItems(i) = item

                pgBar.Value = i
                lbStatus.Text = "Synchronizing Product " & item.name & "(" & item.purchaseDescription & ") ..."
                Application.DoEvents()
                Debug.Write(item.name & vbCrLf)
                dbRs.MoveNext()
                i = i + 1
            End While

            If messagesPresent Then
                msgSetRs = sessionManager.DoRequests(msgSetRq)
                processItemInventoryResponse(msgSetRs)
                Debug.Write(msgSetRs.ToXMLString)
            End If
            pgBar.Value = 0

        Catch ex As Exception
            MessageBox.Show(ex.Message & vbCrLf & vbCrLf & ex.StackTrace, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            MessageBox.Show("Source: " & ex.Source)
            Return
        Finally
            If Not sessionManager Is Nothing Then
                sessionManager.EndSession()
                sessionManager.CloseConnection()
            End If
        End Try
    End Sub

    Sub SynchCustomers()
        Dim strSQL As String
        Dim dbCommand As New ADODB.Command
        Dim dbRs As New ADODB.Recordset
        Dim lastCreatedDate As String = "0000-00-00 00:00:00"
        Dim lastModifiedDate As String = "0000-00-00 00:00:00"

        dbCommand.ActiveConnection = dbConn
        dbRs.CursorType = ADODB.CursorTypeEnum.adOpenStatic
        dbRs.LockType = ADODB.LockTypeEnum.adLockPessimistic

        If cbxPerformanceLogic.Checked Then
            ' Determine the last modified and last created that was synchronized
            strSQL = "SELECT MAX(customers_info_date_account_created) as last_created_date, " & _
                     "MAX(customers_info_date_account_last_modified) as last_modified_date " & _
                     "FROM customers c INNER JOIN customers_info ci ON (c . customers_id =ci . customers_info_id ) " & _
                     "WHERE c.qb_edit_seq is not null"
            dbCommand.CommandText = strSQL
            dbRs = dbCommand.Execute

            If Not dbRs.EOF And Not isDBNull(dbRs.Fields("last_created_date").Value) Then
                lastCreatedDate = Format(dbRs.Fields("last_created_date").Value, "yyyy-MM-dd 00:00:00")
                lastModifiedDate = Format(dbRs.Fields("last_modified_date").Value, "yyyy-MM-dd 00:00:00")
            End If
        End If

        ' Query the database
        strSQL = "SELECT " & _
                    "c.customers_id , c.qb_list_id, c.qb_edit_seq, " & _
                    "a.entry_company , customers_lastname, customers_firstname, " & _
                    "customers_group_name, customers_email_address, " & _
                    "customers_telephone, customers_fax, " & _
                    "COALESCE(customers_notes,'') customers_notes, " & _
                    "entry_firstname, entry_lastname, " & _
                    "entry_street_address, entry_city, entry_postcode, " & _
                    "zone_code, zone_name, countries_name, i_notes.note as internal_notes " & _
                "FROM customers c " & _
                "LEFT JOIN customers_info ci ON ( c.customers_id = ci.customers_info_id ) " & _
                "LEFT JOIN customers_internal_notes i_notes ON (c.customers_id=i_notes.customers_id) " & _
                "LEFT JOIN customers_groups cg " & _
                    "ON (c.customers_group_id=cg.customers_group_id) " & _
                "LEFT JOIN address_book a " & _
                    "ON (c.customers_id = a.customers_id AND c.customers_default_address_id = a.address_book_id) " & _
                "LEFT JOIN zones z " & _
                    "ON (a.entry_zone_id=z.zone_id AND a.entry_country_id=z.zone_country_id) " & _
                "LEFT JOIN countries ct " & _
                    "ON (a.entry_country_id=ct.countries_id) " & _
                "WHERE " & _
                    "ci.customers_info_id IS NULL " & _
                    "OR c.qb_list_id IS NULL " & _
                    "OR ci.customers_info_date_account_created > '" & lastCreatedDate & "' " & _
                    "OR ci.customers_info_date_account_last_modified > '" & lastModifiedDate & "' " & _
                "ORDER BY c.customers_id "


        dbCommand.CommandText = "SELECT count(*) " & _
                                "FROM customers c LEFT JOIN customers_info ci ON (c.customers_id=ci.customers_info_id) " & _
                                "WHERE " & _
                                "ci.customers_info_id IS NULL " & _
                                "OR c.qb_list_id is NULL " & _
                                "OR ci.customers_info_date_account_created > '" & lastCreatedDate & "' " & _
                                "OR ci.customers_info_date_account_last_modified > '" & lastModifiedDate & "'"
        dbRs = dbCommand.Execute
        dbRs.MoveFirst()
        Dim customerCount = dbRs.Fields(0).Value
        dbCommand.CommandText = strSQL
        dbRs = dbCommand.Execute

        Dim sessionManager As QBSessionManager
        Dim msgSetRs As IMsgSetResponse

        pgBar.Minimum = 0
        pgBar.Maximum = customerCount
        Dim i As Integer = 0
        Dim cust As Customer


        Try
            sessionManager = New QBSessionManagerClass
            Dim msgSetRq As IMsgSetRequest = sessionManager.CreateMsgSetRequest("US", 5, 0)
            sessionManager.OpenConnection("osc2QB", "osCommerce Integration Program")
            sessionManager.BeginSession("", ENOpenMode.omDontCare)

            msgSetRq.Attributes.OnError = ENRqOnError.roeContinue
            Dim messagesPresent As Boolean = False

            While Not dbRs.EOF
                ReDim Preserve dbCustomers(i)
                cust = New Customer

                cust.id = FixNull(dbRs.Fields("customers_id").Value)
                cust.listId = FixNull(dbRs.Fields("qb_list_id").Value)
                cust.editSequence = FixNull(dbRs.Fields("qb_edit_seq").Value)
                cust.setCompanyName(FixNull(dbRs.Fields("entry_company").Value))
                cust.setLastName(FixNull(dbRs.Fields("customers_lastname").Value))
                cust.setFirstName(FixNull(dbRs.Fields("customers_firstname").Value))
                cust.group = FixNull(dbRs.Fields("customers_group_name").Value)

                cust.setStreetAddress(FixNull(dbRs.Fields("entry_street_address").Value))
                cust.setCity(FixNull(dbRs.Fields("entry_city").Value))
                cust.setState(FixNull(dbRs.Fields("zone_code").Value))
                cust.postcode = FixNull(dbRs.Fields("entry_postcode").Value)
                cust.setCountry(FixNull(dbRs.Fields("countries_name").Value))

                If (cust.group = "Retail") Then
                    cust.salesTaxCode = "Tax"
                Else
                    cust.salesTaxCode = "Non"
                End If

                If (cust.country = "United States" Or cust.country = "USA") Then
                    cust.country = "USA"
                    If cust.state = "CA" Or cust.state = "California" Then
                        cust.setSalesTaxCode("Tax")
                    Else
                        cust.setSalesTaxCode("OOS")
                    End If
                Else
                    cust.setSalesTaxCode("Non")
                End If

                cust.setEmailAddress(FixNull(dbRs.Fields("customers_email_address").Value))
                cust.setTelephone(FixNull(dbRs.Fields("customers_telephone").Value))
                cust.setFax(FixNull(dbRs.Fields("customers_fax").Value))
                cust.setNotes(FixNull(dbRs.Fields("customers_notes").Value) & FixNull(dbRs.Fields("internal_notes").Value))
                Debug.Write("cust.id = '" & cust.id & "' ")
                Debug.Write("cust.streetAddress = '" & cust.streetAddress & "' ")
                Debug.Write("cust.streetAddress2 = '" & cust.streetAddress2 & "' ")
                Debug.Write("cust.streetAddress3 = '" & cust.streetAddress3 & "' ")
                Debug.Write("cust.streetAddress4 = '" & cust.streetAddress4 & "' ")
                Debug.Write("cust.city = '" & cust.city & "'")
                Debug.Write("cust.state = '" & cust.state & "'")
                Debug.Write("cust.postcode = '" & cust.postcode & "'")
                Debug.Write("cust.country = '" & cust.country & "'")

                If (Len(cust.editSequence) = 0 And Len(cust.listId) = 0) Then
                    BuildCustomerAddRq(cust, msgSetRq, "US")
                    Debug.WriteLine("ADDING :" & cust.getQBName)

                Else
                    BuildCustomerModRq(cust, msgSetRq, "US")
                    Debug.WriteLine("UPDATING :" & cust.getQBName)
                End If
                messagesPresent = True
                If msgSetRq.RequestList.Count > 50 Then
                    lbStatus.Text = "Committing Customer batch to QuickBooks..."
                    Debug.Write(msgSetRq.ToXMLString)

                    msgSetRs = sessionManager.DoRequests(msgSetRq)
                    processCustomerResponse(msgSetRs)
                    Debug.WriteLine("COUNT: " & msgSetRq.RequestList.Count)
                    msgSetRq.ClearRequests()
                    msgSetRq = Nothing
                    msgSetRq = sessionManager.CreateMsgSetRequest("US", 5, 0)
                    msgSetRq.Attributes.OnError = ENRqOnError.roeContinue
                    messagesPresent = False
                End If
                dbCustomers(i) = cust

                pgBar.Value = i
                lbStatus.Text = "Synchronizing Customer " & cust.getQBName & "..."
                Application.DoEvents()
                Debug.Write(cust.getQBName & vbCrLf)
                dbRs.MoveNext()
                i = i + 1
            End While

            If messagesPresent Then
                msgSetRs = sessionManager.DoRequests(msgSetRq)
                processCustomerResponse(msgSetRs)
                Debug.Write(msgSetRs.ToXMLString)
            End If
            pgBar.Value = 0

        Catch ex As Exception
            MessageBox.Show(ex.Message & vbCrLf & vbCrLf & ex.StackTrace, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        Finally
            If Not sessionManager Is Nothing Then
                sessionManager.EndSession()
                sessionManager.CloseConnection()
            End If
        End Try

    End Sub


    Public Function isDBNull(ByVal dbValue) As Boolean
        Return dbValue Is DBNull.Value
    End Function

    Public Function FixNull(ByVal dbValue) As String
        If dbValue Is DBNull.Value Then
            Return ""
        Else
            'NOTE: This will cast value to string if
            'it isn't a string.

            Return dbValue.ToString
        End If
    End Function

    Public Function stripTags(ByVal s As String) As String
        stripTags = Regex.Replace(s, "<[^>]*>", " ")
    End Function
End Module
